diff --git a/dirsrvtests/tests/suites/replication/cleanallruv_test.py b/dirsrvtests/tests/suites/replication/cleanallruv_test.py
index afed323..2ac9961 100644
--- a/dirsrvtests/tests/suites/replication/cleanallruv_test.py
+++ b/dirsrvtests/tests/suites/replication/cleanallruv_test.py
@@ -1,5 +1,5 @@
 # --- BEGIN COPYRIGHT BLOCK ---
-# Copyright (C) 2015 Red Hat, Inc.
+# Copyright (C) 2016 Red Hat, Inc.
 # All rights reserved.
 #
 # License: GPL (version 3 or any later version).
@@ -20,11 +20,10 @@ from lib389._constants import *
 from lib389.properties import *
 from lib389.tasks import *
 from lib389.utils import *
+
 logging.getLogger(__name__).setLevel(logging.DEBUG)
 log = logging.getLogger(__name__)
 
-installation1_prefix = None
-
 
 class AddUsers(threading.Thread):
     def __init__(self, inst, num_users):
@@ -34,7 +33,8 @@ class AddUsers(threading.Thread):
         self.num_users = num_users
 
     def openConnection(self, inst):
-        # Open a new connection to our LDAP server
+        """Open a new connection to our LDAP server"""
+
         server = DirSrv(verbose=False)
         args_instance[SER_HOST] = inst.host
         args_instance[SER_PORT] = inst.port
@@ -45,7 +45,8 @@ class AddUsers(threading.Thread):
         return server
 
     def run(self):
-        # Start adding users
+        """Start adding users"""
+
         conn = self.openConnection(self.inst)
         idx = 0
 
@@ -53,9 +54,10 @@ class AddUsers(threading.Thread):
             USER_DN = 'uid=' + self.inst.serverid + '_' + str(idx) + ',' + DEFAULT_SUFFIX
             try:
                 conn.add_s(Entry((USER_DN, {'objectclass': 'top extensibleObject'.split(),
-                           'uid': 'user' + str(idx)})))
+                                            'uid': 'user' + str(idx)})))
+
+            # One of the masters was probably put into read only mode - just break out
             except ldap.UNWILLING_TO_PERFORM:
-                # One of the masters was probably put into read only mode - just break out
                 break
             except ldap.ALREADY_EXISTS:
                 pass
@@ -67,38 +69,23 @@ class AddUsers(threading.Thread):
         conn.close()
 
 
-def remove_master4_agmts(msg, topology):
-    """Remove all the repl agmts to master4.
-    """
+def remove_master4_agmts(msg, topology_m4):
+    """Remove all the repl agmts to master4. """
+
     log.info('%s: remove all the agreements to master 4...' % msg)
-    try:
-        topology.master1.agreement.delete(DEFAULT_SUFFIX,
-                                          topology.master4.host,
-                                          topology.master4.port)
-    except ldap.LDAPError as e:
-        log.fatal('%s: Failed to delete agmt(m1 -> m4), error: %s' %
-                  (msg, str(e)))
-        assert False
-    try:
-        topology.master2.agreement.delete(DEFAULT_SUFFIX,
-                                          topology.master4.host,
-                                          topology.master4.port)
-    except ldap.LDAPError as e:
-        log.fatal('%s: Failed to delete agmt(m2 -> m4), error: %s' %
-                  (msg, str(e)))
-        assert False
-    try:
-        topology.master3.agreement.delete(DEFAULT_SUFFIX,
-                                          topology.master4.host,
-                                          topology.master4.port)
-    except ldap.LDAPError as e:
-        log.fatal('%s: Failed to delete agmt(m3 -> m4), error: ' %
-                  (msg, str(e)))
-        assert False
+    for num in range(1, 4):
+        try:
+            topology_m4.ms["master{}".format(num)].agreement.delete(DEFAULT_SUFFIX,
+                                                                    topology_m4.ms["master4"].host,
+                                                                    topology_m4.ms["master4"].port)
+        except ldap.LDAPError as e:
+            log.fatal('{}: Failed to delete agmt(m{} -> m4), error: {}'.format(msg, num, str(e)))
+            assert False
 
 
-def check_ruvs(msg, topology):
+def check_ruvs(msg, topology_m4):
     """Check masters 1- 3 for master 4's rid."""
+
     clean = False
     count = 0
     while not clean and count < 10:
@@ -106,13 +93,12 @@ def check_ruvs(msg, topology):
 
         # Check master 1
         try:
-            entry = topology.master1.search_s(DEFAULT_SUFFIX,
-                                              ldap.SCOPE_SUBTREE,
-                                              REPLICA_RUV_FILTER)
+            entry = topology_m4.ms["master1"].search_s(DEFAULT_SUFFIX,
+                                                       ldap.SCOPE_SUBTREE,
+                                                       REPLICA_RUV_FILTER)
             if not entry:
                 log.error('%s: Failed to find db tombstone entry from master' %
                           msg)
-                repl_fail(replica_inst)
             elements = entry[0].getValues('nsds50ruv')
             for ruv in elements:
                 if 'replica 4' in ruv:
@@ -127,13 +113,12 @@ def check_ruvs(msg, topology):
 
         # Check master 2
         try:
-            entry = topology.master2.search_s(DEFAULT_SUFFIX,
-                                              ldap.SCOPE_SUBTREE,
-                                              REPLICA_RUV_FILTER)
+            entry = topology_m4.ms["master2"].search_s(DEFAULT_SUFFIX,
+                                                       ldap.SCOPE_SUBTREE,
+                                                       REPLICA_RUV_FILTER)
             if not entry:
                 log.error('%s: Failed to find tombstone entry from master' %
                           msg)
-                repl_fail(replica_inst)
             elements = entry[0].getValues('nsds50ruv')
             for ruv in elements:
                 if 'replica 4' in ruv:
@@ -148,13 +133,12 @@ def check_ruvs(msg, topology):
 
         # Check master 3
         try:
-            entry = topology.master3.search_s(DEFAULT_SUFFIX,
-                                              ldap.SCOPE_SUBTREE,
-                                              REPLICA_RUV_FILTER)
+            entry = topology_m4.ms["master3"].search_s(DEFAULT_SUFFIX,
+                                                       ldap.SCOPE_SUBTREE,
+                                                       REPLICA_RUV_FILTER)
             if not entry:
                 log.error('%s: Failed to find db tombstone entry from master' %
                           msg)
-                repl_fail(replica_inst)
             elements = entry[0].getValues('nsds50ruv')
             for ruv in elements:
                 if 'replica 4' in ruv:
@@ -173,7 +157,7 @@ def check_ruvs(msg, topology):
     return clean
 
 
-def task_done(topology, task_dn, timeout=60):
+def task_done(topology_m4, task_dn, timeout=60):
     """Check if the task is complete"""
     attrlist = ['nsTaskLog', 'nsTaskStatus', 'nsTaskExitCode',
                 'nsTaskCurrentItem', 'nsTaskTotalItems']
@@ -182,7 +166,7 @@ def task_done(topology, task_dn, timeout=60):
 
     while not done and count < timeout:
         try:
-            entry = topology.master1.getEntry(task_dn, attrlist=attrlist)
+            entry = topology_m4.ms["master1"].getEntry(task_dn, attrlist=attrlist)
             if not entry or entry.nsTaskExitCode:
                 done = True
                 break
@@ -197,270 +181,7 @@ def task_done(topology, task_dn, timeout=60):
     return done
 
 
-class TopologyReplication(object):
-    def __init__(self, master1, master2, master3, master4, m1_m2_agmt, m1_m3_agmt, m1_m4_agmt):
-        master1.open()
-        self.master1 = master1
-        master2.open()
-        self.master2 = master2
-        master3.open()
-        self.master3 = master3
-        master4.open()
-        self.master4 = master4
-
-        # Store the agreement dn's for future initializations
-        self.m1_m2_agmt = m1_m2_agmt
-        self.m1_m3_agmt = m1_m3_agmt
-        self.m1_m4_agmt = m1_m4_agmt
-
-
-@pytest.fixture(scope="module")
-def topology(request):
-    global installation1_prefix
-    if installation1_prefix:
-        args_instance[SER_DEPLOYED_DIR] = installation1_prefix
-
-    # Creating master 1...
-    master1 = DirSrv(verbose=False)
-    args_instance[SER_HOST] = HOST_MASTER_1
-    args_instance[SER_PORT] = PORT_MASTER_1
-    args_instance[SER_SERVERID_PROP] = SERVERID_MASTER_1
-    args_instance[SER_CREATION_SUFFIX] = DEFAULT_SUFFIX
-    args_master = args_instance.copy()
-    master1.allocate(args_master)
-    instance_master1 = master1.exists()
-    if instance_master1:
-        master1.delete()
-    master1.create()
-    master1.open()
-    master1.replica.enableReplication(suffix=SUFFIX, role=REPLICAROLE_MASTER, replicaId=REPLICAID_MASTER_1)
-    master1.log = log
-
-    # Creating master 2...
-    master2 = DirSrv(verbose=False)
-    args_instance[SER_HOST] = HOST_MASTER_2
-    args_instance[SER_PORT] = PORT_MASTER_2
-    args_instance[SER_SERVERID_PROP] = SERVERID_MASTER_2
-    args_instance[SER_CREATION_SUFFIX] = DEFAULT_SUFFIX
-    args_master = args_instance.copy()
-    master2.allocate(args_master)
-    instance_master2 = master2.exists()
-    if instance_master2:
-        master2.delete()
-    master2.create()
-    master2.open()
-    master2.replica.enableReplication(suffix=SUFFIX, role=REPLICAROLE_MASTER, replicaId=REPLICAID_MASTER_2)
-
-    # Creating master 3...
-    master3 = DirSrv(verbose=False)
-    args_instance[SER_HOST] = HOST_MASTER_3
-    args_instance[SER_PORT] = PORT_MASTER_3
-    args_instance[SER_SERVERID_PROP] = SERVERID_MASTER_3
-    args_instance[SER_CREATION_SUFFIX] = DEFAULT_SUFFIX
-    args_master = args_instance.copy()
-    master3.allocate(args_master)
-    instance_master3 = master3.exists()
-    if instance_master3:
-        master3.delete()
-    master3.create()
-    master3.open()
-    master3.replica.enableReplication(suffix=SUFFIX, role=REPLICAROLE_MASTER, replicaId=REPLICAID_MASTER_3)
-
-    # Creating master 4...
-    master4 = DirSrv(verbose=False)
-    args_instance[SER_HOST] = HOST_MASTER_4
-    args_instance[SER_PORT] = PORT_MASTER_4
-    args_instance[SER_SERVERID_PROP] = SERVERID_MASTER_4
-    args_instance[SER_CREATION_SUFFIX] = DEFAULT_SUFFIX
-    args_master = args_instance.copy()
-    master4.allocate(args_master)
-    instance_master4 = master4.exists()
-    if instance_master4:
-        master4.delete()
-    master4.create()
-    master4.open()
-    master4.replica.enableReplication(suffix=SUFFIX, role=REPLICAROLE_MASTER, replicaId=REPLICAID_MASTER_4)
-
-    #
-    # Create all the agreements
-    #
-    # Creating agreement from master 1 to master 2
-    properties = {RA_NAME:      'meTo_%s:%s' % (master2.host, master2.port),
-                  RA_BINDDN:    defaultProperties[REPLICATION_BIND_DN],
-                  RA_BINDPW:    defaultProperties[REPLICATION_BIND_PW],
-                  RA_METHOD:    defaultProperties[REPLICATION_BIND_METHOD],
-                  RA_TRANSPORT_PROT: defaultProperties[REPLICATION_TRANSPORT]}
-    m1_m2_agmt = master1.agreement.create(suffix=SUFFIX, host=master2.host, port=master2.port, properties=properties)
-    if not m1_m2_agmt:
-        log.fatal("Fail to create a master -> master replica agreement")
-        sys.exit(1)
-    log.debug("%s created" % m1_m2_agmt)
-
-    # Creating agreement from master 1 to master 3
-    properties = {RA_NAME:      'meTo_%s:%s' % (master3.host, master3.port),
-                  RA_BINDDN:    defaultProperties[REPLICATION_BIND_DN],
-                  RA_BINDPW:    defaultProperties[REPLICATION_BIND_PW],
-                  RA_METHOD:    defaultProperties[REPLICATION_BIND_METHOD],
-                  RA_TRANSPORT_PROT: defaultProperties[REPLICATION_TRANSPORT]}
-    m1_m3_agmt = master1.agreement.create(suffix=SUFFIX, host=master3.host, port=master3.port, properties=properties)
-    if not m1_m3_agmt:
-        log.fatal("Fail to create a master -> master replica agreement")
-        sys.exit(1)
-    log.debug("%s created" % m1_m3_agmt)
-
-    # Creating agreement from master 1 to master 4
-    properties = {RA_NAME:      'meTo_%s:%s' % (master4.host, master4.port),
-                  RA_BINDDN:    defaultProperties[REPLICATION_BIND_DN],
-                  RA_BINDPW:    defaultProperties[REPLICATION_BIND_PW],
-                  RA_METHOD:    defaultProperties[REPLICATION_BIND_METHOD],
-                  RA_TRANSPORT_PROT: defaultProperties[REPLICATION_TRANSPORT]}
-    m1_m4_agmt = master1.agreement.create(suffix=SUFFIX, host=master4.host, port=master4.port, properties=properties)
-    if not m1_m4_agmt:
-        log.fatal("Fail to create a master -> master replica agreement")
-        sys.exit(1)
-    log.debug("%s created" % m1_m4_agmt)
-
-    # Creating agreement from master 2 to master 1
-    properties = {RA_NAME:      'meTo_%s:%s' % (master1.host, master1.port),
-                  RA_BINDDN:    defaultProperties[REPLICATION_BIND_DN],
-                  RA_BINDPW:    defaultProperties[REPLICATION_BIND_PW],
-                  RA_METHOD:    defaultProperties[REPLICATION_BIND_METHOD],
-                  RA_TRANSPORT_PROT: defaultProperties[REPLICATION_TRANSPORT]}
-    m2_m1_agmt = master2.agreement.create(suffix=SUFFIX, host=master1.host, port=master1.port, properties=properties)
-    if not m2_m1_agmt:
-        log.fatal("Fail to create a master -> master replica agreement")
-        sys.exit(1)
-    log.debug("%s created" % m2_m1_agmt)
-
-    # Creating agreement from master 2 to master 3
-    properties = {RA_NAME:      'meTo_%s:%s' % (master3.host, master3.port),
-                  RA_BINDDN:    defaultProperties[REPLICATION_BIND_DN],
-                  RA_BINDPW:    defaultProperties[REPLICATION_BIND_PW],
-                  RA_METHOD:    defaultProperties[REPLICATION_BIND_METHOD],
-                  RA_TRANSPORT_PROT: defaultProperties[REPLICATION_TRANSPORT]}
-    m2_m3_agmt = master2.agreement.create(suffix=SUFFIX, host=master3.host, port=master3.port, properties=properties)
-    if not m2_m3_agmt:
-        log.fatal("Fail to create a master -> master replica agreement")
-        sys.exit(1)
-    log.debug("%s created" % m2_m3_agmt)
-
-    # Creating agreement from master 2 to master 4
-    properties = {RA_NAME:      'meTo_%s:%s' % (master4.host, master4.port),
-                  RA_BINDDN:    defaultProperties[REPLICATION_BIND_DN],
-                  RA_BINDPW:    defaultProperties[REPLICATION_BIND_PW],
-                  RA_METHOD:    defaultProperties[REPLICATION_BIND_METHOD],
-                  RA_TRANSPORT_PROT: defaultProperties[REPLICATION_TRANSPORT]}
-    m2_m4_agmt = master2.agreement.create(suffix=SUFFIX, host=master4.host, port=master4.port, properties=properties)
-    if not m2_m4_agmt:
-        log.fatal("Fail to create a master -> master replica agreement")
-        sys.exit(1)
-    log.debug("%s created" % m2_m4_agmt)
-
-    # Creating agreement from master 3 to master 1
-    properties = {RA_NAME:      'meTo_%s:%s' % (master1.host, master1.port),
-                  RA_BINDDN:    defaultProperties[REPLICATION_BIND_DN],
-                  RA_BINDPW:    defaultProperties[REPLICATION_BIND_PW],
-                  RA_METHOD:    defaultProperties[REPLICATION_BIND_METHOD],
-                  RA_TRANSPORT_PROT: defaultProperties[REPLICATION_TRANSPORT]}
-    m3_m1_agmt = master3.agreement.create(suffix=SUFFIX, host=master1.host, port=master1.port, properties=properties)
-    if not m3_m1_agmt:
-        log.fatal("Fail to create a master -> master replica agreement")
-        sys.exit(1)
-    log.debug("%s created" % m3_m1_agmt)
-
-    # Creating agreement from master 3 to master 2
-    properties = {RA_NAME:      'meTo_%s:%s' % (master2.host, master2.port),
-                  RA_BINDDN:    defaultProperties[REPLICATION_BIND_DN],
-                  RA_BINDPW:    defaultProperties[REPLICATION_BIND_PW],
-                  RA_METHOD:    defaultProperties[REPLICATION_BIND_METHOD],
-                  RA_TRANSPORT_PROT: defaultProperties[REPLICATION_TRANSPORT]}
-    m3_m2_agmt = master3.agreement.create(suffix=SUFFIX, host=master2.host, port=master2.port, properties=properties)
-    if not m3_m2_agmt:
-        log.fatal("Fail to create a master -> master replica agreement")
-        sys.exit(1)
-    log.debug("%s created" % m3_m2_agmt)
-
-    # Creating agreement from master 3 to master 4
-    properties = {RA_NAME:      'meTo_%s:%s' % (master4.host, master4.port),
-                  RA_BINDDN:    defaultProperties[REPLICATION_BIND_DN],
-                  RA_BINDPW:    defaultProperties[REPLICATION_BIND_PW],
-                  RA_METHOD:    defaultProperties[REPLICATION_BIND_METHOD],
-                  RA_TRANSPORT_PROT: defaultProperties[REPLICATION_TRANSPORT]}
-    m3_m4_agmt = master3.agreement.create(suffix=SUFFIX, host=master4.host, port=master4.port, properties=properties)
-    if not m3_m4_agmt:
-        log.fatal("Fail to create a master -> master replica agreement")
-        sys.exit(1)
-    log.debug("%s created" % m3_m4_agmt)
-
-    # Creating agreement from master 4 to master 1
-    properties = {RA_NAME:      'meTo_%s:%s' % (master1.host, master1.port),
-                  RA_BINDDN:    defaultProperties[REPLICATION_BIND_DN],
-                  RA_BINDPW:    defaultProperties[REPLICATION_BIND_PW],
-                  RA_METHOD:    defaultProperties[REPLICATION_BIND_METHOD],
-                  RA_TRANSPORT_PROT: defaultProperties[REPLICATION_TRANSPORT]}
-    m4_m1_agmt = master4.agreement.create(suffix=SUFFIX, host=master1.host, port=master1.port, properties=properties)
-    if not m4_m1_agmt:
-        log.fatal("Fail to create a master -> master replica agreement")
-        sys.exit(1)
-    log.debug("%s created" % m4_m1_agmt)
-
-    # Creating agreement from master 4 to master 2
-    properties = {RA_NAME:      'meTo_%s:%s' % (master2.host, master2.port),
-                  RA_BINDDN:    defaultProperties[REPLICATION_BIND_DN],
-                  RA_BINDPW:    defaultProperties[REPLICATION_BIND_PW],
-                  RA_METHOD:    defaultProperties[REPLICATION_BIND_METHOD],
-                  RA_TRANSPORT_PROT: defaultProperties[REPLICATION_TRANSPORT]}
-    m4_m2_agmt = master4.agreement.create(suffix=SUFFIX, host=master2.host, port=master2.port, properties=properties)
-    if not m4_m2_agmt:
-        log.fatal("Fail to create a master -> master replica agreement")
-        sys.exit(1)
-    log.debug("%s created" % m4_m2_agmt)
-
-    # Creating agreement from master 4 to master 3
-    properties = {RA_NAME:      'meTo_%s:%s' % (master3.host, master3.port),
-                  RA_BINDDN:    defaultProperties[REPLICATION_BIND_DN],
-                  RA_BINDPW:    defaultProperties[REPLICATION_BIND_PW],
-                  RA_METHOD:    defaultProperties[REPLICATION_BIND_METHOD],
-                  RA_TRANSPORT_PROT: defaultProperties[REPLICATION_TRANSPORT]}
-    m4_m3_agmt = master4.agreement.create(suffix=SUFFIX, host=master3.host, port=master3.port, properties=properties)
-    if not m4_m3_agmt:
-        log.fatal("Fail to create a master -> master replica agreement")
-        sys.exit(1)
-    log.debug("%s created" % m4_m3_agmt)
-
-    # Allow the replicas to get situated with the new agreements
-    time.sleep(5)
-
-    #
-    # Initialize all the agreements
-    #
-    master1.agreement.init(SUFFIX, HOST_MASTER_2, PORT_MASTER_2)
-    master1.waitForReplInit(m1_m2_agmt)
-    master1.agreement.init(SUFFIX, HOST_MASTER_3, PORT_MASTER_3)
-    master1.waitForReplInit(m1_m3_agmt)
-    master1.agreement.init(SUFFIX, HOST_MASTER_4, PORT_MASTER_4)
-    master1.waitForReplInit(m1_m4_agmt)
-
-    # Check replication is working...
-    if master1.testReplication(DEFAULT_SUFFIX, master2):
-        log.info('Replication is working.')
-    else:
-        log.fatal('Replication is not working.')
-        assert False
-
-    # Clear out the tmp dir
-    master1.clearTmpDir(__file__)
-    def fin():
-        master1.delete()
-        master2.delete()
-        master3.delete()
-        master4.delete()
-    request.addfinalizer(fin)
-
-    return TopologyReplication(master1, master2, master3, master4, m1_m2_agmt, m1_m3_agmt, m1_m4_agmt)
-
-
-def restore_master4(topology):
+def restore_master4(topology_m4):
     '''
     In our tests will always be removing master 4, so we need a common
     way to restore it for another test
@@ -469,45 +190,46 @@ def restore_master4(topology):
     log.info('Restoring master 4...')
 
     # Enable replication on master 4
-    topology.master4.replica.enableReplication(suffix=SUFFIX, role=REPLICAROLE_MASTER, replicaId=REPLICAID_MASTER_4)
+    topology_m4.ms["master4"].replica.enableReplication(suffix=SUFFIX, role=REPLICAROLE_MASTER,
+                                                        replicaId=REPLICAID_MASTER_4)
 
     #
     # Create agreements from master 4 -> m1, m2 ,m3
     #
     # Creating agreement from master 4 to master 1
-    properties = {RA_NAME:      'meTo_%s:%s' % (topology.master1.host, topology.master1.port),
-                  RA_BINDDN:    defaultProperties[REPLICATION_BIND_DN],
-                  RA_BINDPW:    defaultProperties[REPLICATION_BIND_PW],
-                  RA_METHOD:    defaultProperties[REPLICATION_BIND_METHOD],
+    properties = {RA_NAME: 'meTo_%s:%s' % (topology_m4.ms["master1"].host, topology_m4.ms["master1"].port),
+                  RA_BINDDN: defaultProperties[REPLICATION_BIND_DN],
+                  RA_BINDPW: defaultProperties[REPLICATION_BIND_PW],
+                  RA_METHOD: defaultProperties[REPLICATION_BIND_METHOD],
                   RA_TRANSPORT_PROT: defaultProperties[REPLICATION_TRANSPORT]}
-    m4_m1_agmt = topology.master4.agreement.create(suffix=SUFFIX, host=topology.master1.host,
-                                                   port=topology.master1.port, properties=properties)
+    m4_m1_agmt = topology_m4.ms["master4"].agreement.create(suffix=SUFFIX, host=topology_m4.ms["master1"].host,
+                                                            port=topology_m4.ms["master1"].port, properties=properties)
     if not m4_m1_agmt:
         log.fatal("Fail to create a master -> master replica agreement")
         sys.exit(1)
     log.debug("%s created" % m4_m1_agmt)
 
     # Creating agreement from master 4 to master 2
-    properties = {RA_NAME:      'meTo_%s:%s' % (topology.master2.host, topology.master2.port),
-                  RA_BINDDN:    defaultProperties[REPLICATION_BIND_DN],
-                  RA_BINDPW:    defaultProperties[REPLICATION_BIND_PW],
-                  RA_METHOD:    defaultProperties[REPLICATION_BIND_METHOD],
+    properties = {RA_NAME: 'meTo_%s:%s' % (topology_m4.ms["master2"].host, topology_m4.ms["master2"].port),
+                  RA_BINDDN: defaultProperties[REPLICATION_BIND_DN],
+                  RA_BINDPW: defaultProperties[REPLICATION_BIND_PW],
+                  RA_METHOD: defaultProperties[REPLICATION_BIND_METHOD],
                   RA_TRANSPORT_PROT: defaultProperties[REPLICATION_TRANSPORT]}
-    m4_m2_agmt = topology.master4.agreement.create(suffix=SUFFIX, host=topology.master2.host,
-                                                   port=topology.master2.port, properties=properties)
+    m4_m2_agmt = topology_m4.ms["master4"].agreement.create(suffix=SUFFIX, host=topology_m4.ms["master2"].host,
+                                                            port=topology_m4.ms["master2"].port, properties=properties)
     if not m4_m2_agmt:
         log.fatal("Fail to create a master -> master replica agreement")
         sys.exit(1)
     log.debug("%s created" % m4_m2_agmt)
 
     # Creating agreement from master 4 to master 3
-    properties = {RA_NAME:      'meTo_%s:%s' % (topology.master3.host, topology.master3.port),
-                  RA_BINDDN:    defaultProperties[REPLICATION_BIND_DN],
-                  RA_BINDPW:    defaultProperties[REPLICATION_BIND_PW],
-                  RA_METHOD:    defaultProperties[REPLICATION_BIND_METHOD],
+    properties = {RA_NAME: 'meTo_%s:%s' % (topology_m4.ms["master3"].host, topology_m4.ms["master3"].port),
+                  RA_BINDDN: defaultProperties[REPLICATION_BIND_DN],
+                  RA_BINDPW: defaultProperties[REPLICATION_BIND_PW],
+                  RA_METHOD: defaultProperties[REPLICATION_BIND_METHOD],
                   RA_TRANSPORT_PROT: defaultProperties[REPLICATION_TRANSPORT]}
-    m4_m3_agmt = topology.master4.agreement.create(suffix=SUFFIX, host=topology.master3.host,
-                                                   port=topology.master3.port, properties=properties)
+    m4_m3_agmt = topology_m4.ms["master4"].agreement.create(suffix=SUFFIX, host=topology_m4.ms["master3"].host,
+                                                            port=topology_m4.ms["master3"].port, properties=properties)
     if not m4_m3_agmt:
         log.fatal("Fail to create a master -> master replica agreement")
         sys.exit(1)
@@ -517,39 +239,39 @@ def restore_master4(topology):
     # Create agreements from m1, m2, m3 to master 4
     #
     # Creating agreement from master 1 to master 4
-    properties = {RA_NAME:      'meTo_%s:%s' % (topology.master4.host, topology.master4.port),
-                  RA_BINDDN:    defaultProperties[REPLICATION_BIND_DN],
-                  RA_BINDPW:    defaultProperties[REPLICATION_BIND_PW],
-                  RA_METHOD:    defaultProperties[REPLICATION_BIND_METHOD],
+    properties = {RA_NAME: 'meTo_%s:%s' % (topology_m4.ms["master4"].host, topology_m4.ms["master4"].port),
+                  RA_BINDDN: defaultProperties[REPLICATION_BIND_DN],
+                  RA_BINDPW: defaultProperties[REPLICATION_BIND_PW],
+                  RA_METHOD: defaultProperties[REPLICATION_BIND_METHOD],
                   RA_TRANSPORT_PROT: defaultProperties[REPLICATION_TRANSPORT]}
-    m1_m4_agmt = topology.master1.agreement.create(suffix=SUFFIX, host=topology.master4.host,
-                                                   port=topology.master4.port, properties=properties)
+    m1_m4_agmt = topology_m4.ms["master1"].agreement.create(suffix=SUFFIX, host=topology_m4.ms["master4"].host,
+                                                            port=topology_m4.ms["master4"].port, properties=properties)
     if not m1_m4_agmt:
         log.fatal("Fail to create a master -> master replica agreement")
         sys.exit(1)
     log.debug("%s created" % m1_m4_agmt)
 
     # Creating agreement from master 2 to master 4
-    properties = {RA_NAME:      'meTo_%s:%s' % (topology.master4.host, topology.master4.port),
-                  RA_BINDDN:    defaultProperties[REPLICATION_BIND_DN],
-                  RA_BINDPW:    defaultProperties[REPLICATION_BIND_PW],
-                  RA_METHOD:    defaultProperties[REPLICATION_BIND_METHOD],
+    properties = {RA_NAME: 'meTo_%s:%s' % (topology_m4.ms["master4"].host, topology_m4.ms["master4"].port),
+                  RA_BINDDN: defaultProperties[REPLICATION_BIND_DN],
+                  RA_BINDPW: defaultProperties[REPLICATION_BIND_PW],
+                  RA_METHOD: defaultProperties[REPLICATION_BIND_METHOD],
                   RA_TRANSPORT_PROT: defaultProperties[REPLICATION_TRANSPORT]}
-    m2_m4_agmt = topology.master2.agreement.create(suffix=SUFFIX, host=topology.master4.host,
-                                                   port=topology.master4.port, properties=properties)
+    m2_m4_agmt = topology_m4.ms["master2"].agreement.create(suffix=SUFFIX, host=topology_m4.ms["master4"].host,
+                                                            port=topology_m4.ms["master4"].port, properties=properties)
     if not m2_m4_agmt:
         log.fatal("Fail to create a master -> master replica agreement")
         sys.exit(1)
     log.debug("%s created" % m2_m4_agmt)
 
     # Creating agreement from master 3 to master 4
-    properties = {RA_NAME:      'meTo_%s:%s' % (topology.master4.host, topology.master4.port),
-                  RA_BINDDN:    defaultProperties[REPLICATION_BIND_DN],
-                  RA_BINDPW:    defaultProperties[REPLICATION_BIND_PW],
-                  RA_METHOD:    defaultProperties[REPLICATION_BIND_METHOD],
+    properties = {RA_NAME: 'meTo_%s:%s' % (topology_m4.ms["master4"].host, topology_m4.ms["master4"].port),
+                  RA_BINDDN: defaultProperties[REPLICATION_BIND_DN],
+                  RA_BINDPW: defaultProperties[REPLICATION_BIND_PW],
+                  RA_METHOD: defaultProperties[REPLICATION_BIND_METHOD],
                   RA_TRANSPORT_PROT: defaultProperties[REPLICATION_TRANSPORT]}
-    m3_m4_agmt = topology.master3.agreement.create(suffix=SUFFIX, host=topology.master4.host,
-                                                   port=topology.master4.port, properties=properties)
+    m3_m4_agmt = topology_m4.ms["master3"].agreement.create(suffix=SUFFIX, host=topology_m4.ms["master4"].host,
+                                                            port=topology_m4.ms["master4"].port, properties=properties)
     if not m3_m4_agmt:
         log.fatal("Fail to create a master -> master replica agreement")
         sys.exit(1)
@@ -558,39 +280,39 @@ def restore_master4(topology):
     #
     # Stop the servers - this allows the rid(for master4) to be used again
     #
-    topology.master1.stop(timeout=30)
-    topology.master2.stop(timeout=30)
-    topology.master3.stop(timeout=30)
-    topology.master4.stop(timeout=30)
+    topology_m4.ms["master1"].stop(timeout=30)
+    topology_m4.ms["master2"].stop(timeout=30)
+    topology_m4.ms["master3"].stop(timeout=30)
+    topology_m4.ms["master4"].stop(timeout=30)
 
     #
     # Initialize the agreements
     #
     # m1 -> m2
-    topology.master1.start(timeout=30)
-    topology.master2.start(timeout=30)
+    topology_m4.ms["master1"].start(timeout=30)
+    topology_m4.ms["master2"].start(timeout=30)
     time.sleep(5)
-    topology.master1.agreement.init(SUFFIX, HOST_MASTER_2, PORT_MASTER_2)
-    topology.master1.waitForReplInit(topology.m1_m2_agmt)
+    topology_m4.ms["master1"].agreement.init(SUFFIX, HOST_MASTER_2, PORT_MASTER_2)
+    topology_m4.ms["master1"].waitForReplInit(topology_m4.ms["master1_agmts"]["m1_m2"])
 
     # m1 -> m3
-    topology.master3.start(timeout=30)
+    topology_m4.ms["master3"].start(timeout=30)
     time.sleep(5)
-    topology.master1.agreement.init(SUFFIX, HOST_MASTER_3, PORT_MASTER_3)
-    topology.master1.waitForReplInit(topology.m1_m3_agmt)
+    topology_m4.ms["master1"].agreement.init(SUFFIX, HOST_MASTER_3, PORT_MASTER_3)
+    topology_m4.ms["master1"].waitForReplInit(topology_m4.ms["master1_agmts"]["m1_m3"])
 
     # m1 -> m4
     time.sleep(5)
-    topology.master4.start(timeout=30)
-    topology.master1.agreement.init(SUFFIX, HOST_MASTER_4, PORT_MASTER_4)
-    topology.master1.waitForReplInit(topology.m1_m4_agmt)
+    topology_m4.ms["master4"].start(timeout=30)
+    topology_m4.ms["master1"].agreement.init(SUFFIX, HOST_MASTER_4, PORT_MASTER_4)
+    topology_m4.ms["master1"].waitForReplInit(topology_m4.ms["master1_agmts"]["m1_m4"])
     time.sleep(5)
 
     #
     # Test Replication is working
     #
     # Check replication is working with previous working master(m1 -> m2)
-    if topology.master1.testReplication(DEFAULT_SUFFIX, topology.master2):
+    if topology_m4.ms["master1"].testReplication(DEFAULT_SUFFIX, topology_m4.ms["master2"]):
         log.info('Replication is working m1 -> m2.')
     else:
         log.fatal('restore_master4: Replication is not working from m1 -> m2.')
